
/* gvSIG. Sistema de Informacin Geogrfica de la Generalitat Valenciana
*
* Copyright (C) 2004 IVER T.I. and Generalitat Valenciana.
*
* This program is free software; you can redistribute it and/or
* modify it under the terms of the GNU General Public License
* as published by the Free Software Foundation; either version 2
* of the License, or (at your option) any later version.
*
* This program is distributed in the hope that it will be useful,
* but WITHOUT ANY WARRANTY; without even the implied warranty of
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
* GNU General Public License for more details.
*
* You should have received a copy of the GNU General Public License
* along with this program; if not, write to the Free Software
* Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307,USA.
*
* For more information, contact:
*
*  Generalitat Valenciana
*   Conselleria d'Infraestructures i Transport
*   Av. Blasco Ibez, 50
*   46010 VALENCIA
*   SPAIN
*
*      +34 963862235
*   gvsig@gva.es
*      www.gvsig.gva.es
*
*    or
*
*   IVER T.I. S.A
*   Salamanca 50
*   46005 Valencia
*   Spain
*
*   +34 963163400
*   dac@iver.es
*/
package es.gva.cit.catalogClient.schemas;
import es.gva.cit.catalogClient.filters.AdditionalClauses;

/**
 * This class is used to define the DublinCore fields that have to be
 * used to do a search.
 * 
 * 
 * @author Jorge Piera Llodra (piera_jor@gva.es)
 */
public class DublinCoreSchema implements ISchemas {
/* (non-Javadoc)
     * @see es.gva.cit.catalogClient.languages.cswProfiles.IProfiles#getCoordinates()
     */

/**
 * 
 * 
 * 
 * @return 
 */
    public String getTitle() {        
        return "title";
    } 
/* (non-Javadoc)
     * @see es.gva.cit.catalogClient.languages.cswProfiles.IProfiles#getCoordinates()
     */

/**
 * 
 * 
 * 
 * @return 
 */
    public String getAbstract() {        
        return "subject";
    } 
/* (non-Javadoc)
     * @see es.gva.cit.catalogClient.languages.cswProfiles.IProfiles#getCoordinates()
     */

/**
 * 
 * 
 * 
 * @return 
 */
    public String getThemeKey() {        
        return "key";
    } 
/* (non-Javadoc)
     * @see es.gva.cit.catalogClient.languages.cswProfiles.IProfiles#getCoordinates()
     */

/**
 * 
 * 
 * 
 * @return 
 */
    public String getScale() {        
        return "scale";
    } 
/* (non-Javadoc)
     * @see es.gva.cit.catalogClient.languages.cswProfiles.IProfiles#getCoordinates()
     */

/**
 * 
 * 
 * 
 * @return 
 */
    public String getProvider() {        
        return "publisher";
    } 
/* (non-Javadoc)
     * @see es.gva.cit.catalogClient.languages.cswProfiles.IProfiles#getCoordinates()
     */

/**
 * 
 * 
 * 
 * @return 
 */
    public String getDateFrom() {        
        return "date";
    } 
/* (non-Javadoc)
     * @see es.gva.cit.catalogClient.languages.cswProfiles.IProfiles#getCoordinates()
     */

/**
 * 
 * 
 * 
 * @return 
 */
    public String getDateTo() {        
        return "date";
    } 
/* (non-Javadoc)
     * @see es.gva.cit.catalogClient.languages.cswProfiles.IProfiles#getCoordinates()
     */

/**
 * 
 * 
 * 
 * @return 
 */
    public String getTopic() {        
        return "topic";
    } 
/* (non-Javadoc)
     * @see es.gva.cit.catalogClient.languages.cswProfiles.IProfiles#getCoordinates()
     */

/**
 * 
 * 
 * 
 * @return 
 */
    public String getCoordinates() {        
        return "spatial";
    } 
/* (non-Javadoc)
     * @see es.gva.cit.catalogClient.languages.cswProfiles.IProfiles#getCoordinates()
     */

/**
 * 
 * 
 * 
 * @return 
 * @param dataset 
 */
    public AdditionalClauses[] getAdditionalClauses(String[] dataset) {        
        return new AdditionalClauses[0];
    } 
/* (non-Javadoc)
     * @see es.gva.cit.catalogClient.languages.cswProfiles.IProfiles#getProviderValue(java.lang.String)
     */

/**
 * 
 * 
 * 
 * @return 
 * @param title 
 * @param filter 
 */
    public String getTitleValue(String title, String filter) {        
	    return envolveWithJokers(title,filter);
    } 
/* (non-Javadoc)
     * @see es.gva.cit.catalogClient.languages.cswProfiles.IProfiles#getCoordinates()
     */

/**
 * 
 * 
 * 
 * @return 
 * @param topic 
 */
    public String getTopicValue(String topic) {        
        return topic;
    } 
/* (non-Javadoc)
     * @see es.gva.cit.catalogClient.languages.cswProfiles.IProfiles#getProviderValue(java.lang.String)
     */

/**
 * 
 * 
 * 
 * @return 
 * @param provider 
 */
    public String getProviderValue(String provider) {        
        return envolveWithJokers(provider,"E");
    } 

/**
 * This funcion envolves the array with an spacial char like *
 * 
 * 
 * @return 
 * @param array 
 * @param filter 
 */
    public String envolveWithJokers(String array, String filter) {        
        if (!(filter.equals("E"))){
            String[] split = array.split(" ");
            String aux = "";
            for (int i=0 ; i<split.length ; i++){
                aux = aux + "*" + split[i] + "* ";
            }
            return aux;
        }
        return "*" + array + "*";
    } 
 }
