
/* gvSIG. Sistema de Informacin Geogrfica de la Generalitat Valenciana
*
* Copyright (C) 2004 IVER T.I. and Generalitat Valenciana.
*
* This program is free software; you can redistribute it and/or
* modify it under the terms of the GNU General Public License
* as published by the Free Software Foundation; either version 2
* of the License, or (at your option) any later version.
*
* This program is distributed in the hope that it will be useful,
* but WITHOUT ANY WARRANTY; without even the implied warranty of
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
* GNU General Public License for more details.
*
* You should have received a copy of the GNU General Public License
* along with this program; if not, write to the Free Software
* Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307,USA.
*
* For more information, contact:
*
*  Generalitat Valenciana
*   Conselleria d'Infraestructures i Transport
*   Av. Blasco Ibez, 50
*   46010 VALENCIA
*   SPAIN
*
*      +34 963862235
*   gvsig@gva.es
*      www.gvsig.gva.es
*
*    or
*
*   IVER T.I. S.A
*   Salamanca 50
*   46005 Valencia
*   Spain
*
*   +34 963163400
*   dac@iver.es
*/
package es.gva.cit.catalogClient.schemas.parsers;
import es.gva.cit.catalogClient.metadataXML.XMLNode;
import es.gva.cit.catalogClient.metadataXML.XMLTree;
import es.gva.cit.catalogClient.querys.Coordinates;
import es.gva.cit.catalogClient.schemas.discoverer.Record;
import es.gva.cit.catalogClient.schemas.discoverer.Resource;

/**
 * This class parses a XMLNode that contains a DublinCore tree
 * 
 * 
 * @author Jorge Piera Llodra (piera_jor@gva.es)
 */
public class DublinCoreParser extends Record {

/**
 * 
 * 
 * 
 * @param node 
 */
    public  DublinCoreParser(XMLNode node) {        
        setNode(node);
        setTitle(XMLTree.searchNodeValue(node,"dc:title"));
        setAbstract_(XMLTree.searchNodeValue(node, "dc:subject"));
        setPurpose(XMLTree.searchNodeValue(node, "dc:description"));
        setResources(getResources(node));  
        
    } 

/**
 * It parses the resource tags
 * 
 * 
 * @return 
 * @param node 
 */
    public Resource[] getResources(XMLNode node) {        
        String format = XMLTree.searchNodeValue(node, "dc:format");
        String source = XMLTree.searchNodeValue(node, "dc:source");
        Coordinates coordinates = new Coordinates(XMLTree.searchNodeValue(getNode(),"dc:spatial->dcmiBox:Box->dcmiBox:westlimit"),
    			XMLTree.searchNodeValue(getNode(),"dc:spatial->dcmiBox:Box->dcmiBox:northlimit"),
				XMLTree.searchNodeValue(getNode(),"dc:spatial->dcmiBox:Box->dcmiBox:eastlimit"),
				XMLTree.searchNodeValue(getNode(),"dc:spatial->dcmiBox:Box->dcmiBox:southlimit"));
        
        if ((source == null) || (format == null)){
            return null;
        }
        
        if (format.toLowerCase().equals("shapefile"))
            format = Resource.DOWNLOAD;
        
        if (format.toLowerCase().trim().equals("web page"))
            format = Resource.WEBSITE;
                     
        Resource[] resources = new Resource[1];
        resources[0] = new Resource(source,format,"","","","",coordinates);
        
       return resources;
    } 
 }
