/* gvSIG. Sistema de Informacin Geogrfica de la Generalitat Valenciana
*
* Copyright (C) 2004 IVER T.I. and Generalitat Valenciana.
*
* This program is free software; you can redistribute it and/or
* modify it under the terms of the GNU General Public License
* as published by the Free Software Foundation; either version 2
* of the License, or (at your option) any later version.
*
* This program is distributed in the hope that it will be useful,
* but WITHOUT ANY WARRANTY; without even the implied warranty of
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
* GNU General Public License for more details.
*
* You should have received a copy of the GNU General Public License
* along with this program; if not, write to the Free Software
* Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307,USA.
*
* For more information, contact:
*
*  Generalitat Valenciana
*   Conselleria d'Infraestructures i Transport
*   Av. Blasco Ibez, 50
*   46010 VALENCIA
*   SPAIN
*
*      +34 963862235
*   gvsig@gva.es
*      www.gvsig.gva.es
*
*    or
*
*   IVER T.I. S.A
*   Salamanca 50
*   46005 Valencia
*   Spain
*
*   +34 963163400
*   dac@iver.es
*/
package com.iver.cit.gvsig;

import javax.swing.JOptionPane;

import org.apache.log4j.Logger;

import com.iver.andami.PluginServices;
import com.iver.andami.plugins.Extension;
import com.iver.andami.ui.mdiManager.IWindow;
import com.iver.cit.gvsig.gui.layout.Layout;
import com.iver.cit.gvsig.gui.layout.fframes.FFrameText;
import com.iver.cit.gvsig.project.documents.layout.fframes.IFFrame;


public class TagExtension extends Extension{
	private static Logger logger = Logger.getLogger(TagExtension.class.getName());
	private Layout layout = null;
	/**
	 * @see com.iver.andami.plugins.IExtension#initialize()
	 */
	public void initialize() {
	}

	/**
	 * @see com.iver.andami.plugins.IExtension#execute(java.lang.String)
	 */
	public void execute(String s) {
		layout = (Layout) PluginServices.getMDIManager().getActiveWindow();

		/* FLayoutZooms zooms = new FLayoutZooms(layout);
		logger.debug("Comand : " + s);
		if (s.compareTo("SET_TAG") == 0) {
			layout.setTool(Layout.SET_TAG);
		} */
        
        // FJP: Cambio: abrimos la ventana de tag para
        // asignar el tag a los elementos seleccionados
        if (s.equals("SET_TAG"))
        {
            IFFrame[] selectedFrames = layout.getFFrameSelected();
            if (selectedFrames.length > 0)
            {
                String defaultStr = "";
                if (selectedFrames.length == 1)
                    defaultStr = selectedFrames[0].getTag();
                String theTag = JOptionPane.showInputDialog(null, "Introduzca el tag:", defaultStr);
                for (int i=0; i< selectedFrames.length; i++)
                    selectedFrames[i].setTag(theTag);
            }
        }
        else if (s.equals("VIEW_TAGS"))
        {
            IFFrame[] frames = layout.getFFrames();
            for (int i=0; i< frames.length; i++)
            {
                IFFrame f = (IFFrame) frames[i];
                if (f instanceof FFrameText)
                {
                    FFrameText txt = (FFrameText) f;
                    if (f.getTag() != null)
                    {
                        txt.clearText();
                        txt.addText(f.getTag());
                    }
                }
            }
            layout.setModeDebug(true);
            layout.refresh();
        }
	}

	/**
	 * @see com.iver.andami.plugins.IExtension#isEnabled()
	 */
	public boolean isEnabled() {
        IWindow f = PluginServices.getMDIManager().getActiveWindow();

        if (f == null) {
            return false;
        }

        if (f.getClass() == Layout.class)
        {
            layout = (Layout) f;        
            IFFrame[] selectedFrames = layout.getFFrameSelected();
            if (selectedFrames == null) return false;
            return (selectedFrames.length > 0);
        }
        return false;
	}

	/**
	 * @see com.iver.andami.plugins.IExtension#isVisible()
	 */
	public boolean isVisible() {
		IWindow f = PluginServices.getMDIManager().getActiveWindow();

		if (f == null) {
			return false;
		}

		if (f instanceof Layout) {
			Layout layout = (Layout) f;

			return true; //layout.m_Display.getMapControl().getMapContext().getLayers().layerCount() > 0;
		} else {
			return false;
		}
	}

}
