package com.iver.cit.gvsig.project.documents.table;

import java.io.IOException;

import com.hardcode.gdbms.engine.values.Value;
import com.iver.cit.gvsig.fmap.core.IRow;
import com.iver.cit.gvsig.fmap.drivers.DriverIOException;
import com.iver.cit.gvsig.fmap.drivers.FieldDescription;
import com.iver.cit.gvsig.fmap.edition.EditionException;


/**
 * DOCUMENT ME!
 *
 * @author Vicente Caballero Navarro
 */
public interface EditionTable {
    /**
     * DOCUMENT ME!
     * @throws EditionException
     */
    public void startEditing() throws EditionException;

    /**
     * DOCUMENT ME!
     */
    public void stopEditing();

    /**
     * DOCUMENT ME!
     *
     * @param index DOCUMENT ME!
     */
    public void hideColumns(int[] index);

    /**
     * DOCUMENT ME!
     *
     * @param index DOCUMENT ME!
     */
    public void setUneditableColumns(int[] index);

    /**
     * DOCUMENT ME!
     *
     * @param numColumns DOCUMENT ME!
     * @param values DOCUMENT ME!
     */
    public void setDefaultValues(int[] numColumns, Value[] values);

    /**
     * DOCUMENT ME!
     *
     * @return DOCUMENT ME!
     */
    public Value getDefaultValue();

    /**
     * DOCUMENT ME!
     *
     * @return DOCUMENT ME!
     */
    // public int[] getSelectedColumns();

    /**
     * DOCUMENT ME!
     * @throws IOException
     */
    public void cancelEditing() throws IOException;

    /**
     * DOCUMENT ME!
     *
     * @return DOCUMENT ME!
     */
    public boolean isEditing();

    /**
     * DOCUMENT ME!
     */
    public void refresh();
    public void addRow(IRow[] rows) throws DriverIOException, IOException;
    public void copyRow() throws DriverIOException, IOException;
    public void cutRow() throws DriverIOException, IOException;
    public void removeRow() throws DriverIOException, IOException;
    public void addColumn(FieldDescription fld);
    public void removeColumn();
    public boolean isCopied();
    public void pasteRow() throws DriverIOException, IOException;

}
