package com.iver.cit.gvsig.project.documents.table.gui;

import java.awt.BorderLayout;
import java.awt.FlowLayout;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;

import javax.swing.JPanel;
import javax.swing.JScrollPane;
import javax.swing.JTextArea;

import org.gvsig.gui.beans.swing.JButton;

import com.iver.andami.PluginServices;
import com.iver.andami.ui.mdiManager.IWindow;
import com.iver.andami.ui.mdiManager.WindowInfo;
/**
 * @author Fernando Gonzlez Corts
 */
public class Statistics extends JPanel implements IWindow {

	private JScrollPane jScrollPane = null;
	private JTextArea txtStatistics = null;
	private JButton jButton = null;
	private JPanel jPanel = null;
	/**
	 * This is the default constructor
	 */
	public Statistics() {
		super();
		initialize();
	}
	/**
	 * This method initializes this
	 * 
	 * @return void
	 */
	private  void initialize() {
		this.setLayout(new BorderLayout());
		this.setSize(300,200);
		this.add(getJScrollPane(), java.awt.BorderLayout.CENTER);
		this.add(getJPanel(), java.awt.BorderLayout.SOUTH);
	}
	/**
	 * This method initializes jScrollPane	
	 * 	
	 * @return javax.swing.JScrollPane	
	 */    
	private JScrollPane getJScrollPane() {
		if (jScrollPane == null) {
			jScrollPane = new JScrollPane();
			jScrollPane.setViewportView(getTxtStatistics());
		}
		return jScrollPane;
	}
	/**
	 * This method initializes jTextArea	
	 * 	
	 * @return javax.swing.JTextArea	
	 */    
	private JTextArea getTxtStatistics() {
		if (txtStatistics == null) {
			txtStatistics = new JTextArea();			
		}
		return txtStatistics;
	}
	/**
	 * This method initializes jButton	
	 * 	
	 * @return JButton	
	 */    
	private JButton getJButton() {
		if (jButton == null) {
			jButton = new JButton();
			jButton.setPreferredSize(new java.awt.Dimension(100,18));
			jButton.setText(PluginServices.getText(this, "cerrar"));
			jButton.addActionListener(new ActionListener() {
                public void actionPerformed(ActionEvent e) {
                    PluginServices.getMDIManager().closeWindow(Statistics.this);
                }
            });
		}
		return jButton;
	}
	/**
	 * This method initializes jPanel	
	 * 	
	 * @return javax.swing.JPanel	
	 */    
	private JPanel getJPanel() {
		if (jPanel == null) {
			jPanel = new JPanel();
			FlowLayout layout = new FlowLayout();
			layout.setAlignment(FlowLayout.RIGHT);
			jPanel.setLayout(layout);
			jPanel.add(getJButton(), null);
		}
		return jPanel;
	}
    /**
     * @see com.iver.andami.ui.mdiManager.IWindow#getWindowInfo()
     */
    public WindowInfo getWindowInfo() {
        WindowInfo vi = new WindowInfo(WindowInfo.MODALDIALOG);
        vi.setTitle(PluginServices.getText(this, "estadisticas"));
        return vi;
    }
    /**
     * @param i
     * @param j
     * @param k
     * @param l
     * @param m
     * @param n
     * @param o
     * @param p
     */
    public void setStatistics(double media, double maximo, double minimo, double varianza, double desviacion, int numero, double ambito, double suma) {
        getTxtStatistics().setText(PluginServices.getText(this, "suma") + ": " + suma + "\n"+
                PluginServices.getText(this, "recuento") + ": " + numero + "\n"+
                PluginServices.getText(this, "media") + ": " + media + "\n"+
                PluginServices.getText(this, "maximo") + ": " + maximo + "\n"+
                PluginServices.getText(this, "minimo") + ": " + minimo + "\n"+
                PluginServices.getText(this, "ambito") + ": " + ambito + "\n"+
                PluginServices.getText(this, "varianza") + ": " + varianza + "\n"+
                PluginServices.getText(this, "desviacion_tipica") + ": " + desviacion);        
    }
    }
