package es.prodevelop.cit.gvsig.arcims.gui.panels.utils;

import com.iver.andami.PluginServices;

/**
* This class simply stores the name, type and status of one services that is
* available in an ArcIMS server. It is used to model the services list in the
* wizard's services JTable.

* @author jldominguez
*/
public class ServiceNamesObject {
	private String serviceName = "";
	private String serviceType = "";
	private String serviceStatus = "";

	public ServiceNamesObject(String name, String type, String status) {
		serviceName = name;
		serviceType = type;
		serviceStatus = status;
	}

	/**
	 * Gets the service name
	*/
	public String getServiceName() {
		return serviceName;
	}

	/**
	 * Gets the service type (ImageService or FeatureService)
	*/
	public String getServiceType() {
		return serviceType;
	}

	/**
	 * Gets the service's status (should be ENABLED)
	*/
	public String getServiceStatus() {
		return serviceStatus;
	}
	
	public String toString() {
		String r = " " + PluginServices.getText(this, "service") + ": " + serviceName + " ";
		return r; 
	}
	
	public String toolTipText() {
		String r = " " + PluginServices.getText(this, "service") + ": " + serviceName +  " \n";
		r = r + " " + PluginServices.getText(this, "service_type") + ": " + serviceType + " \n";
		r = r + " " + PluginServices.getText(this, "status") + ": " + serviceStatus + " ";
		return r; 
	}
}
