package org.gvsig.rasterTools.saveRaster.ui.main;

import java.awt.Color;
import java.awt.FlowLayout;
import java.awt.GridBagConstraints;
import java.awt.GridBagLayout;

import javax.swing.JComboBox;
import javax.swing.JLabel;
import javax.swing.JPanel;
import javax.swing.JTextField;

public class InputScaleDataPanel extends JPanel {

	private JPanel pScale = null;
	private JPanel pResolution = null;
	private JPanel pMtsPixel = null;
	private JLabel lScale = null;
	private JLabel lResolution = null;
	private JLabel lMtsPixel = null;
	private JTextField tScale = null;
	private JTextField tMtsPixel = null;
	private JComboBox cResolution = null;
	/**
	 * This is the default constructor
	 */
	public InputScaleDataPanel() {
		super();
		initialize();
		setActiveScale(0);
	}

	/**
	 * This method initializes this
	 * 
	 * @return void
	 */
	private void initialize() {
		GridBagConstraints gridBagConstraints2 = new GridBagConstraints();
		gridBagConstraints2.gridx = 0;
		gridBagConstraints2.gridy = 2;
		GridBagConstraints gridBagConstraints1 = new GridBagConstraints();
		gridBagConstraints1.gridx = 0;
		gridBagConstraints1.anchor = java.awt.GridBagConstraints.WEST;
		gridBagConstraints1.gridy = 1;
		GridBagConstraints gridBagConstraints = new GridBagConstraints();
		gridBagConstraints.gridx = 0;
		gridBagConstraints.anchor = java.awt.GridBagConstraints.WEST;
		gridBagConstraints.gridy = 0;
		this.setLayout(new GridBagLayout());
		this.setSize(180, 92);
		this.setPreferredSize(new java.awt.Dimension(180,92));
		this.add(getPScale(), gridBagConstraints);
		this.add(getPResolution(), gridBagConstraints1);
		this.add(getPMtsPixel(), gridBagConstraints2);
	}

	/**
	 * This method initializes jPanel	
	 * 	
	 * @return javax.swing.JPanel	
	 */
	private JPanel getPScale() {
		if (pScale == null) {
			FlowLayout flowLayout2 = new FlowLayout();
			flowLayout2.setAlignment(java.awt.FlowLayout.RIGHT);
			lScale = new JLabel();
			lScale.setText("Escala:");
			pScale = new JPanel();
			pScale.setLayout(flowLayout2);
			pScale.setPreferredSize(new java.awt.Dimension(180,29));
			pScale.add(lScale, null);
			pScale.add(getTScale(), null);
		}
		return pScale;
	}

	/**
	 * This method initializes jPanel1	
	 * 	
	 * @return javax.swing.JPanel	
	 */
	private JPanel getPResolution() {
		if (pResolution == null) {
			FlowLayout flowLayout1 = new FlowLayout();
			flowLayout1.setAlignment(java.awt.FlowLayout.RIGHT);
			lResolution = new JLabel();
			lResolution.setText("Resolucin:");
			pResolution = new JPanel();
			pResolution.setLayout(flowLayout1);
			pResolution.setPreferredSize(new java.awt.Dimension(180,34));
			pResolution.add(lResolution, null);
			pResolution.add(getCbResolution(), null);
		}
		return pResolution;
	}

	/**
	 * This method initializes jPanel2	
	 * 	
	 * @return javax.swing.JPanel	
	 */
	private JPanel getPMtsPixel() {
		if (pMtsPixel == null) {
			FlowLayout flowLayout = new FlowLayout();
			flowLayout.setAlignment(java.awt.FlowLayout.RIGHT);
			lMtsPixel = new JLabel();
			lMtsPixel.setText("Mts/Pixel:");
			pMtsPixel = new JPanel();
			pMtsPixel.setLayout(flowLayout);
			pMtsPixel.setPreferredSize(new java.awt.Dimension(180,29));
			pMtsPixel.add(lMtsPixel, null);
			pMtsPixel.add(getTMtsPixel(), null);
		}
		return pMtsPixel;
	}

	/**
	 * This method initializes jTextField	
	 * 	
	 * @return javax.swing.JTextField	
	 */
	public JTextField getTScale() {
		if (tScale == null) {
			tScale = new JTextField();
			tScale.setPreferredSize(new java.awt.Dimension(80,19));
		}
		return tScale;
	}

	/**
	 * This method initializes jTextField2	
	 * 	
	 * @return javax.swing.JTextField	
	 */
	public JTextField getTMtsPixel() {
		if (tMtsPixel == null) {
			tMtsPixel = new JTextField();
			tMtsPixel.setPreferredSize(new java.awt.Dimension(80,19));
		}
		return tMtsPixel;
	}

	/**
	 * This method initializes jComboBox	
	 * 	
	 * @return javax.swing.JComboBox	
	 */
	public JComboBox getCbResolution() {
		if (cResolution == null) {
			cResolution = new JComboBox();
			cResolution.setPreferredSize(new java.awt.Dimension(80,24));
			cResolution.addItem(75+"");
			cResolution.addItem(150+"");
			cResolution.addItem(300+"");
			cResolution.addItem(600+"");
		}
		return cResolution;
	}

	/**
	 * Pone como activo el input scale o mts por pixel dependiendo del
	 * valor del parmetro. 
	 * @param active Si vale 0 activa la Escala y desactiva mts/pixel.
	 * 	Si vale 1 activa mts/pixel y desactiva la Escala.
	 * 	Si vale 2 desactiva ambos.
	 */
	public void setActiveScale(int active){
		Color backgroudColor = getBackground();
		this.getCbResolution().setEnabled(true);
		
		if(active == 0){
			getTScale().setEnabled(true);
			getTMtsPixel().setEnabled(false);
			getTScale().setBackground(Color.white);
			getTMtsPixel().setBackground(backgroudColor);
		}else if(active == 1){
			getTScale().setEnabled(false);
			getTMtsPixel().setEnabled(true);
			getTScale().setBackground(backgroudColor);
			getTMtsPixel().setBackground(Color.white);
		}else if(active == 2){
			getTScale().setEnabled(false);
			getTMtsPixel().setEnabled(false);
			getTScale().setBackground(backgroudColor);
			getTMtsPixel().setBackground(backgroudColor);
		}
	}
	
	/**
	 * Obtiene la etiqueta de MtsPixel
	 * @return
	 */
	public JLabel getLMtsPixel() {
		return lMtsPixel;
	}

	/**
	 * Obtiene la etiqueta de la Resolucin
	 * @return
	 */
	public JLabel getLResolution() {
		return lResolution;
	}

	/**
	 * Obtiene la etiqueta de la Escala
	 * @return
	 */
	public JLabel getLScale() {
		return lScale;
	}
	
}
