/*
 * Cresques Mapping Suite. Graphic Library for constructing mapping applications.
 *
 * Copyright (C) 2004-5.
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307,USA.
 *
 * For more information, contact:
 *
 * cresques@gmail.com
 */
package org.gvsig.rasterTools.saveRaster.ui.properties;

import javax.swing.JPanel;

import org.cresques.io.GeoRasterWriter;
import org.cresques.ui.DefaultDialogPanel;
import org.cresques.ui.raster.DataInputProps;
import org.gvsig.rasterTools.saveRaster.ui.listener.DataInputPropsListener;



/**
 * Panel que contiene el panel de propiedades del salvado a raster
 * @author Nacho Brodin (brodin_ign@gva.es)
 */
public class SaveRasterPropsDialogPanel extends DefaultDialogPanel {
    final private static long 			serialVersionUID = -3370601314380922368L;
    private GeoRasterWriter 			writer = null;
    private String 						formato = null;
    private DataInputPropsListener		listener = null;

    /**
     * Constructor.
     * @param writer
     */
    public SaveRasterPropsDialogPanel(GeoRasterWriter writer) {
    	super(false);
        this.writer = writer;
        this.formato = writer.getIdent();

        //Creamos el listener
        listener = new DataInputPropsListener((DataInputProps)getContentPanel());
        ((DataInputPropsListener) listener).setDialogPanel(this);
        listener.setWriter(writer);
        
        initialize();
    }

    /**
     * This method initializes this
     * @return void
     */
    public void initialize() {
    	this.setLocation(new java.awt.Point(0,0));
        this.setSize(new java.awt.Dimension(360,230));
        super.initialize();
        //Ocultamos el botn de aplicar
        this.getApplyButton().setVisible(false);
    }

    /**
     * This method obtain the SavePropsSetupPanel
     */
    public JPanel getContentPanel() {
        if (contentPane == null) {
        	contentPane = new DataInputProps(this.writer);
            contentPane.setBounds(14, 12, 360, 174);
        }
        return contentPane;
    }

	public DataInputPropsListener getListener() {
		return listener;
	}
}
