package org.cresques.filter.enhancement;

import java.awt.Image;

import org.cresques.filter.RasterBuf;


/**
 * 
 * @author Miguel Ángel Querol Carratalá <querol_mig@gva.es>
 *
 */
public class BrightnessShortFilter extends BrightnessFilter{

	public BrightnessShortFilter(){
		super();
	}
	
	public void pre(){
		exec = true;
		this.raster = (RasterBuf) params.get("raster");
		height = raster.getHeight();
        width = raster.getWidth();
		this.incrBrillo = ((Integer) params.get("incrBrillo")).intValue();
		
		super.pre();
	}
	
	

	public void process(int x, int y) {
		raster.getElemInt(x, y, px);
		
		for(int i = 0 ; i < 3 ; i++){
			if((px[i] + incrBrillo) > 255)
				px[i] = 255;
			else if((px[i] + incrBrillo) < 0)
				px[i] = 0;
			else
				px[i] += incrBrillo;
		}
		
		raster.setElemInt(x, y, px);
		
	}

	public void processLine(int y) {
		// TODO Auto-generated method stub
		
	}

	public int getInRasterDataType() {
		return RasterBuf.TYPE_SHORT;
	}

	public int getOutRasterDataType() {
		return RasterBuf.TYPE_SHORT;
	}

	public Object getResult(String name) {
		if (name.equals("raster")) {
            return (Object) this.raster;
        } else {
            return null;
        }
	}
	
}
