package org.gvsig.remoteClient.gml.schemas;

import java.util.Vector;

/* gvSIG. Sistema de Informacin Geogrfica de la Generalitat Valenciana
 *
 * Copyright (C) 2004 IVER T.I. and Generalitat Valenciana.
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307,USA.
 *
 * For more information, contact:
 *
 *  Generalitat Valenciana
 *   Conselleria d'Infraestructures i Transport
 *   Av. Blasco Ibez, 50
 *   46010 VALENCIA
 *   SPAIN
 *
 *      +34 963862235
 *   gvsig@gva.es
 *      www.gvsig.gva.es
 *
 *    or
 *
 *   IVER T.I. S.A
 *   Salamanca 50
 *   46005 Valencia
 *   Spain
 *
 *   +34 963163400
 *   dac@iver.es
 */
/* CVS MESSAGES:
 *
 * $Id: XMLSchema.java,v 1.1 2006/08/10 12:00:49 jorpiell Exp $
 * $Log: XMLSchema.java,v $
 * Revision 1.1  2006/08/10 12:00:49  jorpiell
 * Primer commit del driver de Gml
 *
 *
 */
/**
 * This class represent a XSD schema file
 * @author Jorge Piera Llodr (piera_jor@gva.es)
 */
public class XMLSchema {
	private XMLSchema parent = null;
	private Vector children = null;
	private String name = null;
	private String location = null;
	
	public XMLSchema(String name,String location) {
		super();
		this.name = name;
		this.location = location;
		children = new Vector();
	}
	
	/**
	 * @return Returns the children.
	 */
	public Vector getChildren() {
		return children;
	}
	
	/**
	 * @return Returns the location.
	 */
	public String getLocation() {
		return location;
	}
	
	/**
	 * @return Returns the name.
	 */
	public String getName() {
		return name;
	}
	
	/**
	 * @return Returns the parent.
	 */
	public XMLSchema getParent() {
		return parent;
	}

	/**
	 * @param location The location to set.
	 */
	public void setLocation(String location) {
		this.location = location;
	}

	/**
	 * @param parent The parent to set.
	 */
	public void setParent(XMLSchema parent) {
		this.parent = parent;
	}
	
	public void addChidren(XMLSchema schema){
		this.children.add(schema);
	}
}
