package org.gvsig.remoteClient.gml.v2;

import java.util.ArrayList;

import org.gvsig.remoteClient.gml.GMLSimpleFeature;


/* gvSIG. Sistema de Informacin Geogrfica de la Generalitat Valenciana
 *
 * Copyright (C) 2004 IVER T.I. and Generalitat Valenciana.
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307,USA.
 *
 * For more information, contact:
 *
 *  Generalitat Valenciana
 *   Conselleria d'Infraestructures i Transport
 *   Av. Blasco Ibez, 50
 *   46010 VALENCIA
 *   SPAIN
 *
 *      +34 963862235
 *   gvsig@gva.es
 *      www.gvsig.gva.es
 *
 *    or
 *
 *   IVER T.I. S.A
 *   Salamanca 50
 *   46005 Valencia
 *   Spain
 *
 *   +34 963163400
 *   dac@iver.es
 */
/* CVS MESSAGES:
 *
 * $Id: GMLSimpleFeature_v2.java,v 1.1 2006/08/10 12:00:49 jorpiell Exp $
 * $Log: GMLSimpleFeature_v2.java,v $
 * Revision 1.1  2006/08/10 12:00:49  jorpiell
 * Primer commit del driver de Gml
 *
 *
 */
/**
 * @author Jorge Piera Llodr (piera_jor@gva.es)
 */
public class GMLSimpleFeature_v2 extends GMLSimpleFeature {
	private ArrayList params  = null;
	private ArrayList values  = null;
	private Object geom = null;
	
	public GMLSimpleFeature_v2(String name, ArrayList params, ArrayList values, Object geom) {
		super(name);
		this.params = params;
		this.values = values;
		this.geom = geom;
	}

	/**
	 * Gets tha attribute name
	 * @param attName
	 * @return
	 */
	public String getAttribute(String attName){
		for (int i=0 ; i<params.size() ; i++){
			if (params.get(i).equals(attName)){
				return (String)values.get(i);
			}
		}
		return null;
	}

	/**
	 * @return Returns the fields.
	 */
	public ArrayList getParams() {
		return params;
	}

	/**
	 * @return Returns the geom.
	 */
	public Object getGeom() {
		return geom;
	}

	/**
	 * @return Returns the values.
	 */
	public ArrayList getValues() {
		return values;
	}


	

	
	
}
